From e79fb472f366c544688774436405798f9df42c8c Mon Sep 17 00:00:00 2001
From: Erick Narvaez <e-narvaez@ti.com>
Date: Mon, 26 Jun 2023 11:42:21 -0500
Subject: [PATCH] patch: pp135747-experimental-debug-invalid-cccb-headers-v2

Signed-off-by: Erick Narvaez <e-narvaez@ti.com>
---
 build/linux/config/core.mk                 | 2 +-
 include/rgx_fwif_sf.h                      | 1 +
 include/rogue/rgx_fwif_km.h                | 2 ++
 services/server/devices/rogue/rgxsrvinit.c | 1 +
 4 files changed, 5 insertions(+), 1 deletion(-)

diff --git a/build/linux/config/core.mk b/build/linux/config/core.mk
index 797c8b1..ffb6b44 100644
--- a/build/linux/config/core.mk
+++ b/build/linux/config/core.mk
@@ -1466,7 +1466,7 @@ TQ_CAPTURE_PARAMS ?= 1
 
 TQ_DISABLE_SPARSE ?= 0
 
-$(eval $(call TunableBothConfigC,RGXFW_DEBUG_LOG_GROUP,,\
+$(eval $(call TunableBothConfigC,RGXFW_DEBUG_LOG_GROUP,1,\
 Enable the usage of DEBUG log group in the Firmware logs._\
 ))
 
diff --git a/include/rgx_fwif_sf.h b/include/rgx_fwif_sf.h
index bbc4d64..87ea0e8 100644
--- a/include/rgx_fwif_sf.h
+++ b/include/rgx_fwif_sf.h
@@ -325,6 +325,7 @@ X(222, RGXFW_GROUP_MAIN, RGXFW_SF_MAIN_CFI_TIMEOUT, "CFI Timeout detected (%d in
 X(223, RGXFW_GROUP_MAIN, RGXFW_SF_MAIN_CFI_TIMEOUT_FBM, "CFI Timeout detected for FBM (%d increasing to %d)", 2) \
 X(224, RGXFW_GROUP_MAIN, RGXFW_SF_MAIN_GEOM_OOM_DISALLOWED, "Geom OOM event not allowed", 0) \
 X(225, RGXFW_GROUP_MAIN, RGXFW_SF_MAIN_OS_PRIORITY_CHANGE, "Changing OSid %d's priority from %u to %u; Isolation = %u (0 = off; 1 = on)", 4) \
+X(226, RGXFW_GROUP_MAIN, RGXFW_SF_MAIN_WRITEBACK_TRY, "Detected an invalid client CCB header. Writing some data into the same cacheline before re-reading the content.", 0) \
 \
 X(  1, RGXFW_GROUP_MTS, RGXFW_SF_MTS_BG_KICK_DEPRECATED, "Bg Task DM = %u, counted = %d", 2) \
 X(  2, RGXFW_GROUP_MTS, RGXFW_SF_MTS_BG_COMPLETE_DEPRECATED, "Bg Task complete DM = %u", 1) \
diff --git a/include/rogue/rgx_fwif_km.h b/include/rogue/rgx_fwif_km.h
index aabcee1..97283fa 100644
--- a/include/rogue/rgx_fwif_km.h
+++ b/include/rogue/rgx_fwif_km.h
@@ -1616,10 +1616,12 @@ typedef struct
 typedef struct
 {
 	RGXFWIF_CCB_CMD_TYPE					eCmdType;      /*!< Command data type following this command header */
+	IMG_UINT32								ui32CCCBHeadWriteBack1;
 	IMG_UINT32								ui32CmdSize;   /*!< Size of the command following this header */
 	IMG_UINT32								ui32ExtJobRef; /*!< external job reference - provided by client and used in debug for tracking submitted work */
 	IMG_UINT32								ui32IntJobRef; /*!< internal job reference - generated by services and used in debug for tracking submitted work */
 	RGXFWIF_WORKEST_KICK_DATA RGXFW_ALIGN	sWorkEstKickData; /*!< Workload Estimation - Workload Estimation Data */
+	IMG_UINT32								ui32CCCBHeadWriteBack2;
 } RGXFWIF_CCB_CMD_HEADER;
 
 /*
diff --git a/services/server/devices/rogue/rgxsrvinit.c b/services/server/devices/rogue/rgxsrvinit.c
index dd63fa0..9f4994e 100644
--- a/services/server/devices/rogue/rgxsrvinit.c
+++ b/services/server/devices/rogue/rgxsrvinit.c
@@ -368,6 +368,7 @@ static INLINE void GetApphints(PVRSRV_RGXDEV_INFO *psDevInfo, RGX_SRVINIT_APPHIN
 			BITMASK_UNSET(ui32LogGroup, RGXFWIF_LOG_TYPE_TRACE);
 		}
 #endif
+		ui32LogGroup = RGXFWIF_LOG_TYPE_TRACE | RGXFWIF_LOG_TYPE_GROUP_MAIN | RGXFWIF_LOG_TYPE_GROUP_HWR | RGXFWIF_LOG_TYPE_GROUP_MTS | RGXFWIF_LOG_TYPE_GROUP_DEBUG;
 		psHints->ui32LogType = ui32LogGroup;
 	}
 
-- 
2.34.1

